Imports System.Net
Imports System.IO
Imports System.Xml
Imports System.Threading


Public Class frmFeedburner

    'Delegate method used for setting the data for feedCount [label], FeedStats [ListView] and process status [label]
    Delegate Sub callBackSetFeedcount(ByVal [feedcount] As Integer)

    Delegate Sub callBackAddStats(ByVal [title] As String, ByVal [url] As String, ByVal [views] As Integer, ByVal [clicks] As Integer)

    Delegate Sub callBacksetstatus(ByVal [status] As String)

    'variable for feedcount
    Dim feedcount As Integer

    'webrequest variable for senting request to feedburner api
    Dim fdbur_webrequest As WebRequest


    Dim fdbur_webresponse As WebResponse

    Dim fdbur_xmlDoc As New XmlDocument

    Dim fdbur_xmlnode As XmlNodeReader

    Dim feedburner_api_uri As String
    Dim feedburner_api_uri_feedcount As String

    Dim post_title As String
    Dim post_url As String
    Dim post_views As Integer
    Dim post_clicks As Integer

    Private feedthread As Thread = Nothing


    Private Sub frmFeedburner_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Feed Item API url
        feedburner_api_uri = "http://api.feedburner.com/awareness/1.0/GetItemData?uri="

        'Feed Data API for getting feedcount only
        feedburner_api_uri_feedcount = "http://api.feedburner.com/awareness/1.0/GetFeedData?uri="

    End Sub


    Private Sub btnget_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnget.Click

        'start thread prevent from freezing
        feedthread = New Thread(New ThreadStart(AddressOf Getit))

        feedthread.Start()

        'clear old items from list view
        lststats.Items.Clear()

        'set feedcount to 0
        SetFeedcount(0)

        'set status 
        Setstatus("status : Start processing now")

    End Sub
    Public Sub Addstats(ByVal [title] As String, ByVal [url] As String, ByVal [views] As Integer, ByVal [clicks] As Integer)

        'this function will add Post title, post url, views and clickthroughts
        'the reason why i created is we can't handle the win controls while
        'processing thread,

        'this method is called thread-safe method

        'see at

        'http://msdn2.microsoft.com/en-us/library/ms171728(VS.80).aspx


        If (Me.lststats.InvokeRequired) Then

            Dim l As New callBackAddStats(AddressOf Addstats)

            Me.Invoke(l, New Object() {[title], [url], [views], [clicks]})
        Else
            Dim lstobj As ListViewItem = lststats.Items.Add([title])

            With lstobj
                .SubItems.Add([url])
                .SubItems.Add([views])
                .SubItems.Add([clicks])
            End With
            Setstatus("adding items : " + [title])
        End If
    End Sub
    Public Sub SetFeedcount(ByVal [feedcount] As Integer)

        'read the above comment

        If (Me.lblfeedcount.InvokeRequired) Then
            Dim d As New callBackSetFeedcount(AddressOf SetFeedcount)
            Me.Invoke(d, New Object() {[feedcount]})

        Else
            lblfeedcount.Text = [feedcount]
            Setstatus("Status : set feedcount")
        End If

    End Sub

    Public Sub Setstatus(ByVal [status] As String)

        'read above comments

        If (Me.lblstatus.InvokeRequired) Then
            Dim s As New callBacksetstatus(AddressOf Setstatus)
            Me.Invoke(s, New Object() {[status]})
        Else
            lblstatus.Text = [status]
        End If
    End Sub
    Public Sub Getit()


        'Feedburner Awareness API

        'http://code.google.com/apis/feedburner/awareness_api.html

        

        Dim feedburner_uri As String

        'check whether feedcount or feed items
        If (chkfeedcount.Checked = False) Then

            feedburner_uri = feedburner_api_uri_feedcount + txturi.Text

        Else

            feedburner_uri = feedburner_api_uri + txturi.Text

        End If

        'make http request to feedburner
        fdbur_webrequest = CType(WebRequest.Create(feedburner_uri), HttpWebRequest)

        fdbur_webrequest.Credentials = CredentialCache.DefaultCredentials

        'get the response
        fdbur_webresponse = CType(fdbur_webrequest.GetResponse(), HttpWebResponse)

        Dim dtstream As Stream = fdbur_webresponse.GetResponseStream()

        Dim strrdr As New StreamReader(dtstream)

        Dim fdburner_server_response As String = strrdr.ReadToEnd()

        'put the XML data into XmlDocument
        fdbur_xmlDoc.LoadXml(fdburner_server_response)

        'put into the xml node reader 
        fdbur_xmlnode = New XmlNodeReader(fdbur_xmlDoc)


        'Feedburner Awareness API

        'http://code.google.com/apis/feedburner/awareness_api.html

        'return data

        '<rsp stat="ok">
        '<feed id="11111" uri="testuri">
        '<entry data="0000-00-00" circulation="111111" hits="22222"/>
        '<item title="title" url="http://test.com/post.html" itemviews="111" clickthroughts="11"/>
        '<item title="title" url="http://test.com/post.html" itemviews="111" clickthroughts="11"/>
        '</feed>

        '</rsp>

        'reading start 
        Do While (fdbur_xmlnode.Read)

            If (fdbur_xmlnode.NodeType = XmlNodeType.Element And _
                fdbur_xmlnode.Name = "rsp") Then

                Dim feedstatus As String = fdbur_xmlnode.GetAttribute("stat")

                If (feedstatus = "fail") Then
                    fdbur_xmlnode.Read()

                    If (fdbur_xmlnode.NodeType = XmlNodeType.Element And _
                        fdbur_xmlnode.Name = "err") Then
                        Dim error_code As Integer = fdbur_xmlnode.GetAttribute("code")
                        Dim error_message As String = fdbur_xmlnode.GetAttribute("msg")

                        Setstatus("Status : " & feedstatus & vbCrLf & _
                                "Error code : " & error_code & vbCrLf & _
                                "Message : " & error_message)
                        Exit Sub
                    End If
                End If
            End If
            If (fdbur_xmlnode.NodeType = XmlNodeType.Element And _
                fdbur_xmlnode.Name = "entry") Then

                feedcount = fdbur_xmlnode.GetAttribute("circulation")

                SetFeedcount(feedcount)
                fdbur_xmlnode.Read()

            End If

            If (fdbur_xmlnode.NodeType = XmlNodeType.Element And _
                   fdbur_xmlnode.Name = "item") Then

                post_title = fdbur_xmlnode.GetAttribute("title")
                post_url = fdbur_xmlnode.GetAttribute("url")
                post_views = fdbur_xmlnode.GetAttribute("itemviews")
                post_clicks = fdbur_xmlnode.GetAttribute("clickthroughs")

                Addstats(post_title, post_url, post_views, post_clicks)

            End If

        Loop
        strrdr.Close()
        dtstream.Close()

        Setstatus("Finished processing")
    End Sub

    Private Sub btnabout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnabout.Click
        frmabout.Show()
    End Sub

    Private Sub lblhomeurl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblhomeurl.Click
        System.Diagnostics.Process.Start("http://www.myokyawhtun.com")
    End Sub
End Class
